build_helper 28.4 KB
Newer Older
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34
#/*
# * Licensed to the OpenAirInterface (OAI) Software Alliance under one or more
# * contributor license agreements.  See the NOTICE file distributed with
# * this work for additional information regarding copyright ownership.
# * The OpenAirInterface Software Alliance licenses this file to You under
# * the OAI Public License, Version 1.1  (the "License"); you may not use this file
# * except in compliance with the License.
# * You may obtain a copy of the License at
# *
# *      http://www.openairinterface.org/?page_id=698
# *
# * Unless required by applicable law or agreed to in writing, software
# * distributed under the License is distributed on an "AS IS" BASIS,
# * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# * See the License for the specific language governing permissions and
# * limitations under the License.
# *-------------------------------------------------------------------------------
# * For more information about the OpenAirInterface (OAI) Software Alliance:
# *      contact@openairinterface.org
# */

# file build_helper
# brief
# authors Laurent Thomas, Lionel GAUTHIER
#
#######################################
if [ ! -f /etc/os-release ]; then
  echo "No /etc/os-release file found. You're likely on an unsupported distro."
  exit -1
fi
OS_DISTRO=$(grep "^ID=" /etc/os-release | sed "s/ID=//" | sed "s/\"//g")
OS_RELEASE=$(grep "^VERSION_ID=" /etc/os-release | sed "s/VERSION_ID=//" | sed "s/\"//g")
case "$OS_DISTRO" in
  fedora) OS_BASEDISTRO="fedora"; INSTALLER="dnf"; CMAKE="cmake" ;;
35
  rhel)   OS_BASEDISTRO="fedora"; INSTALLER="dnf"; CMAKE="cmake3" ;;
36
  rocky)  OS_BASEDISTRO="fedora"; INSTALLER="dnf"; CMAKE="cmake" ;;
37
  centos) OS_BASEDISTRO="centos"; INSTALLER="yum"; CMAKE="cmake3" ;;
38 39 40 41 42 43
  debian) OS_BASEDISTRO="debian"; INSTALLER="apt-get"; CMAKE="cmake" ;;
  ubuntu) OS_BASEDISTRO="debian"; INSTALLER="apt-get"; CMAKE="cmake" ;;
esac
KERNEL_VERSION=$(uname -r | cut -d '.' -f1)
KERNEL_MAJOR=$(uname -r | cut -d '.' -f2)

44
#check if we run inside a container
45
IS_CONTAINER=`egrep -c "docker|podman|kubepods|libpod|buildah" /proc/self/cgroup || true`
46 47
#sudo is not needed when we are root
if [ "$UID" = 0 ]
48 49
then
  SUDO=''
50 51
else
  SUDO='sudo -S -E'
52
fi
53 54 55 56

###############################
## echo and  family
###############################
57 58 59 60 61 62 63 64 65 66 67
# only emit color if connected to a terminal, and if it supports colors
if [ -t 1 ]; then
  num_colors=$(tput colors)
  if [ -n "$num_colors" ] && [ "$num_colors" -ge 8 ]; then
    red='\E[31m'
    green='\E[32m'
    yellow='\E[33m'
    blue='\E[1;34m'
    reset_color='\E[00m'
  fi
fi
68

69
cecho()  {
70 71 72 73 74 75
    # Color-echo
    # arg1 = message
    # arg2 = color
    local default_msg="No Message."
    message=${1:-$default_msg}
    color=${2:-$green}
76
    echo -e "$color$message$reset_color"
77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105
    return
}

echo_error()   { cecho "$*" $red          ;}
echo_fatal()   { cecho "$*" $red; exit -1 ;}
echo_warning() { cecho "$*" $yellow       ;}
echo_success() { cecho "$*" $green        ;}
echo_info()    { cecho "$*" $blue         ;}

########################
# distribution helpers #
########################

# This function return a string to identify the distribution we are running
# If we can't check the distribution, it returns "Unknown"
# This function return always true as exit code by design
# Examples:
#   debian8.5
get_distribution_release() {
    if [[ ! -z "$OS_DISTRO$OS_RELEASE" ]]; then
        echo "$OS_DISTRO$OS_RELEASE"
    else
        echo Unknown
    fi
}

check_supported_distribution() {
    local distribution=$(get_distribution_release)
    case "$distribution" in
laurent's avatar
laurent committed
106
        "ubuntu23.10") return 0 ;;
Robert Schmidt's avatar
Robert Schmidt committed
107
        "ubuntu22.04") return 0 ;;
108 109
        "ubuntu21.04") return 0 ;;
        "ubuntu20.04") return 0 ;;
110
        "ubuntu18.04") return 0 ;;
111
        "debian11")    return 0 ;;
112
        "fedora36")    return 0 ;;
113
        "fedora37")    return 0 ;;
114
        "rhel7")       return 0 ;;
cig's avatar
cig committed
115
        "rhel7.6")     return 0 ;;
116
        "rhel7.7")     return 0 ;;
117
        "rhel7.8")     return 0 ;;
Eurecom's avatar
Eurecom committed
118
        "rhel7.9")     return 0 ;;
119
        "rhel8.2")     return 0 ;;
120 121
        "rhel8.3")     return 0 ;;
        "rhel8.4")     return 0 ;;
122 123 124
        "rhel8.5")     return 0 ;;
        "rhel8.6")     return 0 ;;
        "rhel8.7")     return 0 ;;
125 126
        "rhel8.8")     return 0 ;;
        "rhel8.9")     return 0 ;;
Eurecom's avatar
Eurecom committed
127
        "rhel9.0")     return 0 ;;
128
        "rhel9.1")     return 0 ;;
Raphael Defosseux's avatar
Raphael Defosseux committed
129 130
        "rhel9.2")     return 0 ;;
        "rhel9.3")     return 0 ;;
131
        "rhel9.4")     return 0 ;;
132
        "centos7")     return 0 ;;
133
        "centos8")     return 0 ;;
134 135 136 137 138 139
        "rocky8.7")    return 0 ;;
        "rocky8.8")    return 0 ;;
        "rocky8.9")    return 0 ;;
        "rocky9.1")    return 0 ;;
        "rocky9.2")    return 0 ;;
        "rocky9.3")    return 0 ;;
140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182
    esac
    return 1
}

##################
# Error handlers #
##################

handler_EXIT() {
	local exit_code=$?
    [ "$exit_code" -eq 0 ] || echo_error "build have failed"
	exit $exit_code
}

trap handler_EXIT EXIT

###########################
# Cleaners
###########################

clean_kernel() {
    $SUDO modprobe ip_tables
    $SUDO modprobe x_tables
    $SUDO iptables -P INPUT ACCEPT
    $SUDO iptables -F INPUT
    $SUDO iptables -P OUTPUT ACCEPT
    $SUDO iptables -F OUTPUT
    $SUDO iptables -P FORWARD ACCEPT
    $SUDO iptables -F FORWARD
    $SUDO iptables -t nat -F
    $SUDO iptables -t mangle -F
    $SUDO iptables -t filter -F
    $SUDO iptables -t raw -F
    echo_info "Flushed iptables"
    $SUDO rmmod nasmesh > /dev/null 2>&1
    $SUDO rmmod oai_nw_drv  > /dev/null 2>&1
    $SUDO rmmod ue_ip > /dev/null 2>&1
    echo_info "removed drivers from kernel"
}

clean_all_files() {
 set_openair_env
 dir=$OPENAIR_DIR/cmake_targets
laurent's avatar
laurent committed
183 184
 rm -rf $dir/ran_build $dir/ran_build_noLOG
 rm -rf $dir/lte-simulators/build 
185
 rm -rf $dir/nas_sim_tools/build 
186
 rm -rf $dir/oaisim_build_oai/build $dir/oaisim_build_oai/CMakeLists.txt
187
 rm -rf $dir/autotests/bin $dir/autotests/log $dir/autotests/*/build
188 189 190 191 192 193 194 195 196 197 198 199 200 201
}

###################################
# Compilers
###################################

#check_warnings:
#    print error message if the compilation had warnings
#argument:
#    $1: log file
check_warnings() {
  #we look for 'warning:' in the compilation log file
  #this is how gcc starts a warning
  #this is not perfect, we may get false positive
202
  warning_count=`grep "warning:" "$1" | egrep -v "jobserver unavailable|disabling jobserver mode" | wc -l`
203 204 205 206 207
  if [ $warning_count -gt 0 ]; then
    echo_error "WARNING: $warning_count warnings. See $1"
  fi
}

208 209 210 211 212
#check_errors:
#    print error message if the compilation had errors
#argument:
#    $1: log file
check_errors() {
213 214
  #we look for 'error:' in the compilation log file
  error_count=`grep -c "error:" "$1"`
215 216 217 218 219
  if [ $error_count -gt 0 ]; then
    echo_error "ERROR: $error_count error. See $1"
  fi
}

220
compilations() {
221
  [[ $# -gt 2 ]] || echo_fatal "compilations needs more than three arguments"
222 223 224 225 226
  local dir=$1
  shift 1
  local logfile=$1
  shift 1
  local targets=$@
227 228
  local verbose=$([ "$VERBOSE_COMPILE" == "1" ] && echo "-v" || echo "")
  echo cd $OPENAIR_DIR/cmake_targets/$dir/build
229
  cd $OPENAIR_DIR/cmake_targets/$dir/build
230
  echo_info "Running \"$CMAKE --build . $verbose --target $targets -- -j$(nproc)\"" $green
231
  echo "Log file for compilation is being written to: $dlog/$logfile"
232 233
  set +e
  {
234
    $CMAKE --build . $verbose --target $targets -- -j$(nproc)
235
    ret=$?
236
  } > $dlog/$logfile 2>&1
237 238
  # Print the errors and warnings for CI purposes
  egrep -A3 "warning:|error:" $dlog/$logfile || true
239
  check_warnings "$dlog/$logfile"
240
  if [[ $ret -eq 0 ]]; then
241
     echo_success "$targets compiled"
242
  else
243 244
     check_errors "$dlog/$logfile"
     echo_error "compilation of $targets failed"
245 246 247 248 249 250 251 252 253 254 255 256
     exit 1
  fi
}

############################################
# External packages installers
############################################

install_usrp_uhd_driver_from_source(){
    uhd_install_log=$OPENAIR_DIR/cmake_targets/log/uhd_install_log.txt
    echo_info "\nInstalling UHD driver from sources. The log file for UHD driver installation is here: $uhd_install_log "
    (
Raphael Defosseux's avatar
Raphael Defosseux committed
257
    pushd /tmp
258
    echo "Cloning UHD driver repository"
259 260 261
    rm -rf /tmp/uhd
    git clone https://github.com/EttusResearch/uhd.git
    cd uhd
262 263
    # For our legacy TDD eNB running with a B2xx RF board
    # the following patch has to be applied
264 265
    if [[ -v UHD_VERSION ]]; then
        git checkout tags/v${UHD_VERSION}
266 267 268 269 270
        # We recommend to use not older than 3.15.0.0
        if [[ "$UHD_VERSION" == "3.15.0.0" ]]; then
            # Tested that patch for the following versions:
            # - 3.15.0.0
            git apply $OPENAIR_DIR/cmake_targets/tools/uhd-3.15-tdd-patch.diff
271
            ret=$?;[[ $ret -ne 0 ]] && echo_fatal "Could not apply the TDD patch"
272 273 274 275 276 277 278 279
        else
            # Tested that patch for the following versions:
            # - 4.0.0.0
            # - 4.1.0.0
            # - 4.1.0.5
            # - 4.2.0.0
            # - 4.2.0.1
            # - 4.3.0.0-rc1
280
            # - 4.4.0.0
281
            git apply $OPENAIR_DIR/cmake_targets/tools/uhd-4.x-tdd-patch.diff
282
            ret=$?;[[ $ret -ne 0 ]] && echo_fatal "Could not apply the TDD patch"
283
        fi
284 285
    else
        git checkout tags/v4.0.0.0
286
        git apply $OPENAIR_DIR/cmake_targets/tools/uhd-4.x-tdd-patch.diff
287
        ret=$?;[[ $ret -ne 0 ]] && echo_fatal "Could not apply the TDD patch"
288
    fi
289 290
    # Printing out the results of the patch to make sure it was properly applied
    git diff
291
    mkdir -p host/build
292 293
    cd host/build || true
    $CMAKE ../ -GNinja
294
    echo "Compiling UHD"
295 296
    ninja
    $SUDO ninja install
Raphael Defosseux's avatar
Raphael Defosseux committed
297
    $SUDO ldconfig -v
298 299 300 301
    if [ $IS_CONTAINER -eq 0 ]; then
        if [[ "$OS_DISTRO" == "ubuntu" ]]; then
            $SUDO /usr/local/lib/uhd/utils/uhd_images_downloader.py
        fi
302
        if [[ "$OS_DISTRO" == "rhel" ]] || [[ "$OS_DISTRO" == "rocky" ]]; then
303 304 305
            $SUDO /usr/local/lib64/uhd/utils/uhd_images_downloader.py
        fi
    fi
Raphael Defosseux's avatar
Raphael Defosseux committed
306 307
    popd
    rm -rf /tmp/uhd
308 309 310 311
    ) >& $uhd_install_log
}

check_install_usrp_uhd_driver(){
312 313
    if [[ "$OS_BASEDISTRO" == "debian" ]]; then
        boost_libs_ubuntu="libboost-chrono-dev libboost-date-time-dev libboost-filesystem-dev libboost-program-options-dev libboost-thread-dev libboost-test-dev libboost-regex-dev"
314
        #first we remove old installation
315 316 317 318 319 320 321 322 323
        $SUDO apt-get remove uhd -y || true
        $SUDO apt-get remove uhd-host -y || true
        $SUDO apt-get remove libuhd-dev -y || true
        $SUDO apt-get remove libuhd003 -y || true
        $SUDO apt-get remove libuhd3.13.1 -y || true
        $SUDO apt-get remove libuhd3.14.0 -y || true
        $SUDO apt-get remove libuhd3.14.1 -y || true
        $SUDO apt-get remove libuhd3.15.0 -y || true
        local distribution=$(get_distribution_release)
324
        if [[ "$distribution" == "ubuntu18.04" || "$distribution" == "ubuntu20.04" || "$distribution" == "ubuntu22.04" ]]; then
325
            $SUDO apt-get remove libuhd4.?.? -y || true
326
        fi
327 328
        v=$(lsb_release -cs)
        $SUDO apt-add-repository --remove "deb http://files.ettus.com/binaries/uhd/repo/uhd/ubuntu/$v $v main"
329 330
        if [[ -v BUILD_UHD_FROM_SOURCE ]] || [[ "$OS_DISTRO" == "debian" ]]; then
            $SUDO apt-get install -y $boost_libs_ubuntu libusb-1.0-0-dev doxygen python3-docutils python3-mako python3-numpy python3-requests python3-setuptools ninja-build
331 332 333
            install_usrp_uhd_driver_from_source
            return
        fi
334
        # The new USRP repository
335
        # Raphael Defosseux: Adding a loop on adding PPA because in CI the gpg key retrieve may
336 337 338 339 340 341 342 343 344 345 346 347 348 349 350
        # timeout due to proxy / network latencies in Eurecom on VM
        echo_info "\nAdding PPA repository ettusresearch/uhd\n"
        x=0
        while [ $x -le 5 ]
        do
            if $SUDO add-apt-repository ppa:ettusresearch/uhd -y
            then
                echo_info "add-apt-repository successful\n"
                break
            else
                echo_info "add-apt-repository failed, retrying...\n"
                sleep 30
            fi
            x=$((x + 1))
        done
351
        $SUDO apt-get update
352
        $SUDO apt-get -y install python-tk  $boost_libs_ubuntu libusb-1.0-0-dev
353 354
        case "$(get_distribution_release)" in
          "ubuntu18.04" | "ubuntu20.04" | "ubuntu22.04")
355
            $SUDO apt-get -y install libuhd-dev libuhd4.5.0 uhd-host
356 357
            ;;
        esac
358
    elif [[ "$OS_BASEDISTRO" == "fedora" ]]; then
359
        boost_libs_fedora="boost-chrono boost-date-time boost-filesystem boost-program-options boost-thread boost-test boost-regex boost-devel"
Raphael Defosseux's avatar
Raphael Defosseux committed
360 361
        if [ $IS_CONTAINER -eq 0 ]
        then
362 363
            $SUDO $INSTALLER -y install python3 $boost_libs_fedora libusb-devel libusbx-devel  python3-mako python3-docutils python3-pip $CMAKE
            $SUDO pip3 install requests
Raphael Defosseux's avatar
Raphael Defosseux committed
364
        else
365
            $SUDO $INSTALLER -y install $boost_libs_fedora $CMAKE
Raphael Defosseux's avatar
Raphael Defosseux committed
366 367
            $SUDO pip3 install mako requests
        fi
368
        if [[ "$OS_DISTRO" == "rhel" ]] || [[ "$OS_DISTRO" == "centos" ]] || [[ "$OS_DISTRO" == "rocky" ]]; then
Raphael Defosseux's avatar
Raphael Defosseux committed
369 370 371 372 373
            if [ $IS_CONTAINER -eq 0 ]
            then
                # until EPEL repo hasn't bumped UHD driver to >=3.10 in EPEL, build driver from source
                $SUDO $INSTALLER -y remove uhd uhd-devel uhd-firmware
            fi
374 375 376 377 378 379 380 381 382 383 384 385 386
            install_usrp_uhd_driver_from_source
        else
            $SUDO $INSTALLER -y install uhd uhd-devel uhd-firmware
        fi
    fi
}

install_usrp_uhd_driver() {
    if [[ "$OS_DISTRO" == "ubuntu" ]]; then
        # We move uhd-host apart because it depends on linux kernel version
        # On newer kernels, it fails to install
        $SUDO apt-get -y install uhd-host
    fi
387 388
    # quick workaround for RHE7.6
    local distribution=$(get_distribution_release)
389
    if [ -z $1 ]; then
390
      if [[ "$OS_DISTRO" == "rhel" ]] || [[ "$OS_DISTRO" == "rocky" ]]; then
391 392 393 394
          $SUDO /usr/local/bin/uhd_images_downloader
      else
          $SUDO uhd_images_downloader
      fi
395
    else
396
      if [[ "$OS_DISTRO" == "rhel" ]] || [[ "$OS_DISTRO" == "rocky" ]]; then
397 398 399 400
          $SUDO /usr/local/bin/uhd_images_downloader -i $1
      else
          $SUDO uhd_images_downloader -i $1
      fi
401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422
    fi
}

install_bladerf_driver_from_source(){
    bladerf_install_log=$OPENAIR_DIR/cmake_targets/log/bladerf_install_log.txt
    echo_info "\nInstalling BladeRF driver from sources. The log file for BladeRF driver installation is here: $bladerf_install_log "
    (
    cd /tmp
    echo "Downloading BladeRF driver"
    rm -rf /tmp/bladeRF
    git clone https://github.com/Nuand/bladeRF.git
    cd bladeRF
    git checkout tags/2016.06
    mkdir -p build
    cd build
    $CMAKE ../
    echo "Compiling BladeRF driver"
    make
    $SUDO make install
    $SUDO ldconfig
    echo "Downloading FPGA and firmware images"
    cd /tmp/bladeRF
423 424
    #wget has been removed from default dependencies, so we must be sure that's installed
    $SUDO $INSTALLER -y install wget
425 426
    wget --tries=3 --retry-connrefused https://www.nuand.com/fx3/bladeRF_fw_latest.img
    wget --tries=3 --retry-connrefused https://www.nuand.com/fpga/hostedx40-latest.rbf
427 428 429 430 431 432 433 434
    sudo mkdir -p /usr/share/Nuand/bladeRF
    sudo mv bladeRF_fw_latest.img /usr/share/Nuand/bladeRF/bladeRF_fw.img
    sudo mv hostedx40-latest.rbf /usr/share/Nuand/bladeRF/hostedx40.rbf
    ) >& $bladerf_install_log
}

check_install_bladerf_driver(){
    if [[ "$OS_DISTRO" == "ubuntu" ]]; then
435 436 437
        $SUDO apt-get install -y  bladerf libbladerf-dev
        $SUDO apt-get install -y bladerf-firmware-fx3
        $SUDO apt-get install -y bladerf-fpga-hostedx40
438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456
   elif [[ "$OS_BASEDISTRO" == "fedora" ]]; then
        install_bladerf_driver_from_source
   else
        echo_error "BladeRF Installer for OAI does not support automatic build. Install BladeRF compiling sources manually from BladeRF website"
   fi
}

flash_firmware_bladerf() {
	$SUDO bladeRF-cli --flash-firmware /usr/share/Nuand/bladeRF/bladeRF_fw.img
}

check_install_lmssdr_driver(){
	if ( [ -d "/usr/local/include/lime" ] &&
             [ -f "/usr/local/include/lime/LimeSuite.h" ] )
	then
  		echo_success "Found lmssdr drivers and tools installed from source"
        else
                echo_error "lmssdr support implies installing lmssdr drivers and tools" \
                           " from sources. check:"
Laurent's avatar
Laurent committed
457
                echo_info "https://wiki.myriadrf.org/Lime_Suite"
458
                echo_fatal "Cannot compile lmssdr device"
459 460 461 462 463
	fi


}

464 465 466 467 468 469
install_soapy_from_source(){
    soapy_install_log=$OPENAIR_DIR/cmake_targets/log/soapy_install_log.txt
    echo_info "\nInstalling Soapy EcoSystem from source. The log file for Soapy installation is here: $soapy_install_log "
    (
    cd /tmp
    echo "Downloading SoapySDR"
470
    rm -rf /tmp/SoapySDR
Rahman Doost's avatar
Rahman Doost committed
471 472
    git clone -b soapy-sdr-0.7.0 --single-branch https://github.com/pothosware/SoapySDR.git
    cd SoapySDR
473 474 475 476 477 478 479 480 481 482
    #git checkout tags/release_003_010_001_001
    mkdir -p build
    cd build
    $CMAKE ../
    echo "Compiling SoapySDR"
    make -j`nproc`
    $SUDO make install
    $SUDO ldconfig
    cd /tmp
    echo "Downloading SoapyRemote"
483
    rm -rf /tmp/SoapyRemote
Rahman Doost's avatar
Rahman Doost committed
484 485
    git clone -b soapy-remote-0.5.0 --single-branch https://github.com/pothosware/SoapyRemote.git
    cd SoapyRemote
486 487 488
    #git checkout tags/release_003_010_001_001
    mkdir -p build
    cd build
489
    $CMAKE ../
490 491 492 493 494 495 496 497 498 499 500 501 502 503
    echo "Compiling SoapyRemote"
    make -j`nproc`
    $SUDO make install
    $SUDO ldconfig
    ) >& $soapy_install_log
}

install_soapy_iris_from_source(){
    iris_install_log=$OPENAIR_DIR/cmake_targets/log/iris_install_log.txt
    echo_info "\nInstalling Iris driver from source. The log file for Iris driver installation is here: $iris_install_log "
    (
    cd /tmp
    echo "Downloading SoapyIris"
    rm -rf /tmp/sklk-soapyiris
Rahman Doost's avatar
Rahman Doost committed
504
    git clone -b soapy-iris-2018.08.0.1 --single-branch https://github.com/skylarkwireless/sklk-soapyiris.git
505 506 507
    cd sklk-soapyiris
    mkdir -p build
    cd build
508
    $CMAKE ../
509 510 511 512 513 514 515 516 517 518
    echo "Compiling SoapyIris"
    make -j`nproc`
    $SUDO make install
    $SUDO ldconfig
    ) >& $iris_install_log
}

check_install_soapy () {
    #if [[ "$OS_DISTRO" == "ubuntu" ]]; then
        #first we remove old installation
Rahman Doost's avatar
Rahman Doost committed
519 520 521 522
    $SUDO apt-get remove -y soapysdr soapysdr-server libsoapysdr-dev python-soapysdr python3-soapysdr soapysdr-module-remote || true
        #$SUDO add-apt-repository -y ppa:myriadrf/drivers
        #$SUDO apt-get update
        #$SUDO apt-get install -y soapysdr soapysdr-server libsoapysdr-dev python-soapysdr python3-soapysdr soapysdr-module-remote
523 524 525

    #elif [[ "$OS_BASEDISTRO" == "fedora" ]]; then
    #    $SUDO $INSTALLER -y install software-properties-common python3-software-properties python-software-properties subversion git python3 python-numpy python3-numpy cmake swig python-dev
Rahman Doost's avatar
Rahman Doost committed
526
    install_soapy_from_source
527 528
    #fi
    install_soapy_iris_from_source
529
}
530

531
# for ubuntu 18 we need a special repository (https://apt.kitware.com/) to install cmake >= 3.12
532
add_cmake_repo () {
533 534 535 536
  $SUDO $INSTALLER -y install wget
  wget -O - https://apt.kitware.com/keys/kitware-archive-latest.asc 2>/dev/null | gpg --dearmor - | $SUDO tee /usr/share/keyrings/kitware-archive-keyring.gpg >/dev/null
  echo 'deb [signed-by=/usr/share/keyrings/kitware-archive-keyring.gpg] https://apt.kitware.com/ubuntu/ bionic main' | $SUDO tee /etc/apt/sources.list.d/kitware.list >/dev/null
  $SUDO $INSTALLER -y update
537
  $SUDO rm /usr/share/keyrings/kitware-archive-keyring.gpg
538
  $SUDO $INSTALLER -y install kitware-archive-keyring
539 540
}

541 542
check_install_additional_tools (){
  $SUDO $INSTALLER update -y
543
  local optional_packages=""
544
  if [[ "$OS_BASEDISTRO" == "debian" ]]; then
545
    case "$(get_distribution_release)" in
546 547
        "ubuntu18.04")
            optional_packages="python-dev python-pip python-pyroute2 python python-numpy python-scipy python-matplotlib ctags"
548
            ;;
549 550
        "ubuntu20.04" | "ubuntu21.04" | "ubuntu22.04" | "debian11" )
            optional_packages="python3 python3-pip python3-dev python3-scipy python3-matplotlib python3-pyroute2 universal-ctags"
551 552
            ;;
    esac
553
    PACKAGE_LIST="\
554 555 556 557 558 559
        doxygen \
        libgnutls28-dev \
        libpthread-stubs0-dev \
        libqt5charts5-dev \
        tshark \
        uml-utilities \
560
        iperf3 \
561 562
        libforms-bin \
        libforms-dev \
563
        libxft-dev \
564
        xmlstarlet"
565
  elif [[ "$OS_DISTRO" == "rhel" ]] || [[ "$OS_DISTRO" == "centos" ]] || [[ "$OS_DISTRO" == "rocky" ]] ||  [[ "$OS_DISTRO" == "fedora" ]]; then
566
    PACKAGE_LIST="\
567
      doxygen \
568 569
      ctags \
      iperf3 \
570
      gnutls-devel \
571
      libXft-devel \
572 573 574
      xforms \
      xforms-devel \
      xmlstarlet"
575
  fi
576
    $SUDO $INSTALLER install -y $PACKAGE_LIST $optional_packages
577 578 579 580 581 582 583 584 585
}

check_install_oai_software() {
    local specific_packages=""
    if ! check_supported_distribution; then
        echo_error "Your distribution $(get_distribution_release) is not supported by oai !"
        exit 1
    fi
    $SUDO $INSTALLER update -y
586
  if [[ "$OS_BASEDISTRO" == "debian" ]]; then
587 588
    $SUDO apt install -y software-properties-common
    case "$(get_distribution_release)" in
589
        "ubuntu18.04")
590
            add_cmake_repo
591
            specific_packages=""
592 593
            ;;
         "debian11")
594
            specific_packages="libz-dev"
595 596 597 598 599 600
            ;;
    esac
    $SUDO apt-get install -y \
    $specific_packages \
	automake  \
	build-essential \
601
	$CMAKE \
laurent's avatar
laurent committed
602
        ninja-build \
603
	pkg-config \
604 605 606
	git \
	libatlas-base-dev \
	libblas-dev \
607 608
	liblapack-dev \
	liblapacke-dev \
609 610
	libreadline-dev \
	libconfig-dev \
611 612 613
	libsctp-dev  \
	libssl-dev  \
	libtool  \
614
	patch \
615
	openssl \
616
        zlib1g-dev \
617
        xxd
618 619

  elif [[ "$OS_BASEDISTRO" == "fedora" ]]; then
620
    if [[ "$OS_DISTRO" == "rhel" ]] || [[ "$OS_DISTRO" == "centos" ]] || [[ "$OS_DISTRO" == "rocky" ]]; then
621 622 623 624
      if rpm -q epel-release > /dev/null; then
        echo "EPEL repos already present. Good."
      else
        echo "EPEL repos not present. Installing them."
625
        $SUDO $INSTALLER install -y https://dl.fedoraproject.org/pub/epel/epel-release-latest-9.noarch.rpm
626 627
      fi
    fi
628

629 630 631
    $SUDO $INSTALLER install -y \
      automake \
      $CMAKE \
632
      gcc \
633
      gcc-c++ \
634 635
      git \
      atlas-devel \
636
      pkgconfig \
637 638 639 640 641
      libconfig-devel \
      libffi-devel \
      lksctp-tools \
      lksctp-tools-devel \
      libtool \
642 643
      ninja-build \
      make \
644
      openssl \
645
      openssl-devel \
646
      patch \
647
      readline-devel \
648 649 650
      lapack \
      lapack-devel \
      blas \
651
      blas-devel \
Robert Schmidt's avatar
Robert Schmidt committed
652 653
      vim-common \
      zlib-devel
654 655
  fi

656
    install_asn1c_from_source $1
657
    install_simde_from_source $1
658 659 660
}

install_asn1c_from_source(){
661
    mkdir -p $OPENAIR_DIR/cmake_targets/log
662 663 664
    asn1_install_log=$OPENAIR_DIR/cmake_targets/log/asn1c_install_log.txt
    echo_info "\nInstalling ASN1. The log file for ASN1 installation is here: $asn1_install_log "
    (
665
    $SUDO $INSTALLER -y install bison flex
666
    $SUDO rm -rf /tmp/asn1c
667
    # GIT_SSL_NO_VERIFY=true git clone https://gitlab.eurecom.fr/oai/asn1c.git /tmp/asn1c
668
    git clone https://github.com/mouse07410/asn1c /tmp/asn1c
669
    cd /tmp/asn1c
670 671 672 673
    #git checkout vlm_master
    # hotfix: current vlm_master (5fa129cf3161da9ff2d67341e6277e818c0f5d6a)
    # breaks F1, NG, so use the one before.
    git checkout 940dd5fa9f3917913fd487b13dfddfacd0ded06e
674 675
    # Showing which version is used
    git log -n1
676
    autoreconf -iv
677
    ./configure --prefix /opt/asn1c/
678 679 680 681
    make -j`nproc`
    $SUDO make install
    cd -
    $SUDO ldconfig
682 683 684
    if [[ -v CI_ENV ]]; then
        $SUDO rm -rf /tmp/asn1c
    fi
685 686 687
    ) > $asn1_install_log 2>&1
}

688 689
install_simde_from_source(){
    echo_info "\nInstalling SIMDE from source without test cases (header files only)"
690
    cd /tmp
691 692 693
    $SUDO rm -rf /tmp/simde
    git clone https://github.com/simd-everywhere/simde-no-tests.git /tmp/simde
    cd /tmp/simde
694 695 696 697 698 699 700 701 702
    # we can specify a given version of SIMDE (sha-one or tag)
    if [[ -v SIMDE_VERSION ]]; then
      git checkout -f $SIMDE_VERSION
    else
      # At time of writing, last working commit for OAI
      git checkout 389f360a66d4a3bec62b7d71ad8be877487809ba
    fi
    # Showing which version is used
    git log -n1
703 704 705 706
    # brute force copy into /usr/include
    $SUDO \cp -rv ../simde /usr/include
}

Anurag Asokan's avatar
Anurag Asokan committed
707 708 709 710 711 712 713 714 715 716 717 718 719 720 721 722 723 724 725 726 727 728 729 730 731 732 733 734 735 736 737 738 739 740 741 742 743 744 745 746 747 748 749 750 751 752 753 754 755 756 757 758 759 760 761 762 763 764 765 766 767 768 769 770 771 772 773 774 775 776 777 778 779 780 781 782 783 784 785 786 787 788 789 790 791 792 793 794 795 796 797
install_lttng() {
    if [[ "$OS_DISTRO" != "ubuntu" ]]; then
      echo_info "LTTng is supported only for ubuntu at the moment."
      echo_info $distribution
      return
    fi

    set +e
    $SUDO apt-add-repository ppa:lttng/stable-2.13 -y && apt-get update
    $SUDO apt-get install -y lttng-tools lttng-modules-dkms liblttng-ust-dev
    if [[ $? > 0 ]]; then
      echo "Failed to install LTTng using apt. Installing from source"
      install_lttng_deps
      install_lttng_from_source
    fi
    set -e
}

install_lttng_deps() {
  echo "installing dependencies of LTTng"
  $SUDO apt-get install uuid-dev libxml2-dev -y
}

install_lttng_from_source() {
    echo "installing LTTng from source"
    install_popt_1_18_from_source
    install_userspace_rcu
    install_lttng_ust_2_13_from_source
    install_lttng_tools_2_13_from_source
}

install_popt_1_18_from_source() {
  $SUDO $INSTALLER -y install wget
  echo_info "\nInstalling popt_1_18."
  cd $(mktemp -d) &&
  wget http://ftp.rpm.org/popt/releases/popt-1.x/popt-1.18.tar.gz
  tar -xf popt-1.18.tar.gz && cd popt-1.18
  ./configure && make -j16 && $SUDO make install
}

install_userspace_rcu() {
    echo_info "\nInstalling U-RCU from source."
    cd /tmp
    $SUDO rm -rf /tmp/urcu
    git clone https://github.com/urcu/userspace-rcu.git /tmp/urcu
    cd /tmp/urcu
    git checkout stable-0.12
    ./bootstrap && ./configure && make
    $SUDO make install
    $SUDO ldconfig
}


install_lttng_modules_2_13_from_source() {
    $SUDO $INSTALLER -y install wget
    echo_info "\nInstalling LTTng Modules."
    cd $(mktemp -d) &&
    wget https://lttng.org/files/lttng-modules/lttng-modules-latest-2.13.tar.bz2 &&
    tar -xf lttng-modules-latest-2.13.tar.bz2 &&
    cd lttng-modules-2.13.* &&
    make &&
    $SUDO make modules_install &&
    $SUDO depmod -a
}

install_lttng_ust_2_13_from_source() {
    $SUDO $INSTALLER -y install wget
    echo_info "\nInstalling LTTng UST."
    cd $(mktemp -d) &&
    wget https://lttng.org/files/lttng-ust/lttng-ust-latest-2.13.tar.bz2 &&
    tar -xf lttng-ust-latest-2.13.tar.bz2 &&
    cd lttng-ust-2.13.* &&
    ./configure --disable-numa &&
    make &&
    $SUDO make install &&
    $SUDO ldconfig
}

install_lttng_tools_2_13_from_source() {
    $SUDO $INSTALLER -y install wget
    echo_info "\nInstalling LTTng Tools."
    cd $(mktemp -d) &&
    wget https://lttng.org/files/lttng-tools/lttng-tools-latest-2.13.tar.bz2 &&
    tar -xf lttng-tools-latest-2.13.tar.bz2 &&
    cd lttng-tools-2.13.* &&
    ./configure &&
    make &&
    $SUDO make install &&
    $SUDO ldconfig
}

798
#################################################
799
# 2. compile
800 801 802
################################################

install_nas_tools() {
Laurent THOMAS's avatar
Laurent THOMAS committed
803 804 805 806
  echo_success "generate .ue_emm.nvram .ue.nvram"
  ./nvram --gen -c $1 -o $2 > "$3"
  echo_success "generate .usim.nvram"
  ./usim --gen -c $1 -o $2 >> "$3"
807 808 809 810 811 812 813 814 815 816 817
}


################################
# set_openair_env
###############################
set_openair_env(){
    fullpath=`readlink -f $BASH_SOURCE`
    [ -f "/.$fullpath" ] || fullpath=`readlink -f $PWD/$fullpath`
    openair_path=${fullpath%/cmake_targets/*}
    openair_path=${openair_path%/targets/*}
818
    openair_path=${openair_path%/openair[123]/*}
819 820 821 822 823 824 825 826 827 828 829 830 831 832 833 834
    export OPENAIR_DIR=$openair_path
    export OPENAIR1_DIR=$openair_path/openair1
    export OPENAIR2_DIR=$openair_path/openair2
    export OPENAIR3_DIR=$openair_path/openair3
    export OPENAIR_TARGETS=$openair_path/targets
}

################################
# Function to killall the subprocesses when Ctrl-C Key is hit
###############################
function handle_ctrl_c(){
CURPID=$$
ppid=$$
arraycounter=1
echo_info "** Trapped CTRL-C. Killing all subprocesses now..."
echo_info "** Calling sync now..."
835
sync
836 837 838 839 840 841 842 843 844 845 846 847 848 849 850 851 852
while true
do
        FORLOOP=FALSE
        # Get all the child process id
        for i in `ps -ef| awk '$3 == '$ppid' { print $2 }'`
        do
                if [ $i -ne $CURPID ] ; then
                        procid[$arraycounter]=$i
                        arraycounter=`expr $arraycounter + 1`
                        ppid=$i
                        FORLOOP=TRUE
                fi
        done
        if [ "$FORLOOP" = "FALSE" ] ; then
           arraycounter=`expr $arraycounter - 1`
           ## We want to kill child process id first and then parent id's
           while [ $arraycounter -ne 0 ]
853
           do
854 855 856 857 858 859 860 861 862 863 864
             echo "first we send ctrl-c to program"
             $SUDO kill -INT "${procid[$arraycounter]}"
             sleep 5
             echo "Now we force kill if that didn't work"
             $SUDO kill -9 "${procid[$arraycounter]}" >/dev/null
             arraycounter=`expr $arraycounter - 1`
           done
         exit
        fi
done
}